"""Changed datatype of completeness

Revision ID: 57b1f73ba591
Revises: 310616d89f75
Create Date: 2016-02-29 15:56:15.561308

"""

# revision identifiers, used by Alembic.
revision = '57b1f73ba591'
down_revision = '310616d89f75'

from alembic import op
import sqlalchemy as sa


INSERTS = """
UPDATE participations set completeness = '';
"""
DELETES = """"""


def iter_statements(stmts):
    for st in [x for x in stmts.split('\n') if x]:
        op.execute(st)


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.alter_column('participations', 'completeness',
               existing_type=sa.INTEGER(),
               type_=sa.String(),
               existing_nullable=True)
    ### end Alembic commands ###
    iter_statements(INSERTS)


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.alter_column('participations', 'completeness',
               existing_type=sa.String(),
               type_=sa.INTEGER(),
               existing_nullable=True)
    ### end Alembic commands ###
    iter_statements(DELETES)
